<template>
  <div>
    <header>
      <nav>
        <ul class="nav-list">
          <li>
            <router-link to="/home" class="nav-link" active-class="active-link">
              Home
            </router-link>
          </li>
          <li>
            <router-link to="/" class="nav-link" active-class="active-link">
              About
            </router-link>
          </li>
        </ul>
        <div>
          <div v-if="getUser" class="user-profile">    
            <div v-if="isAuthenticated" class="user-profile">
              <div class="user-info">
                <img :src="userPhotoURL" alt="User Profile" class="profile-image" />
                <span class="user-name">{{ userName }}</span>
                <router-link to="/profile" class="profile-button" active-class="active-link">
                  Profile
                </router-link>
              </div>
              <button class="logout-button" @click="signOutMethod">Log out</button>
            </div>
          </div>
          <div v-else>
            <router-link :to="{ name: 'login' }" class="login-link" active-class="active-link">
              Login
            </router-link>
          </div>
        </div>
      </nav>
    </header>
    <router-view />
  </div>
</template>

<script>
//import AsideComponent from "@/components/AsideComponent.vue";
import { mapGetters, mapActions } from 'vuex';
import { auth } from '@/firebase-config.js';
import Token from "@/token-usage.js";

export default {
  components: {
    //AsideComponent,
  },
  computed: {
    ...mapGetters('auth', ['getUser']),
    isAuthenticated() {
      return this.getUser !== null;
    },
    userPhotoURL() {
      return this.getUser ? this.getUser.photoURL : '';
    },
    userName() {
      return this.getUser ? this.getUser.displayName : '';
    },
  },
  created() {
    const userData = Token.getUserDataFromCookie();
    if (userData) {
      this.$store.commit('auth/setUser', userData);
    }
  },
  methods: {
    ...mapActions('auth', ['logout']),
    signOutMethod() {
      this.logout(auth)
        .then(() => {
          Token.removeAccessTokenCookie();
          Token.removeUserDataCookie();  
          console.log('SignOut successful');
          this.$router.push("/");
        })
        .catch((error) => {
          console.log(error);
        });
    },
    goToProfile(){
      this.$router.push('/profile')
    }
  },
};
</script>

<style scoped>
header {
  background-color: #333;
  padding: 1rem;
}

nav {
  display: flex;
  align-items: center;
  justify-content: space-between;
}

.nav-list {
  list-style: none;
  padding: 0;
  margin: 0;
  font-size: x-large;
  display: flex; 
}

.nav-list li {
  margin-right: 1rem;
}

.nav-list li:last-child {
  margin-right: 0;
}

.nav-list a {
  color: white;
  text-decoration: none;
  font-weight: bold;
  transition: color 0.3s ease-in-out;
}

.nav-list a:hover {
  color: #2c7040; 
}
.active-link {
  color: #2c7040;
  font-weight: bold;
}

.user-profile {
  display: flex;
  align-items: center;
}

.user-info {
  display: flex;
  align-items: center;
}

.user-name {
  color: white;
  font-weight: bold;
  margin-left: 10px; 
}

.profile-image {
  max-width: 50px;
  max-height: 50px;
  border-radius: 50%;
}

.logout-button{
  background-color: #5a5769;
  color: white;
  border: none;
  padding: 8px;
  border-radius: 4px;
  cursor: pointer;
  margin-left: 5px;
  transition: background-color 0.3s ease-in-out, color 0.3s ease-in-out;
}


.profile-button,
.login-link {
  background-color: #5a5769;
  color: white;
  border: none;
  padding: 8px;
  border-radius: 4px;
  cursor: pointer;
  margin-left: 5px;
  transition: background-color 0.3s ease-in-out, color 0.3s ease-in-out;
}

.logout-button:hover,
.profile-button:hover,
.login-link:hover {
  background-color: #325872; 
}
</style>
